VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOptionen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum eOtions
    PreviewSpeichern
    ViewGridlines
    ExplorerView
    Unbennantffnen
    TextMarkieren
    ZuletztGeffneteWiederffnen
    IntelliSenseAktiviert
    IntelliSenseIstGleich
    StandardProject
    HTML_Dokumentation
    FTPServer
    FTPUserName
    FTPPasswort
    ExterneAnwendung
    WordWrap
    ZwischenAblageRingElemente
    Schriftart
    Schriftgre
    UmlautKonvertierung
    ProjektExplorerffnen
End Enum

Private mvarINIFile As String

Public Property Let INIFile(ByVal vData As String)

mvarINIFile = vData

End Property

Public Property Get INIFile() As String

INIFile = mvarINIFile

End Property

Private Function GetINISetting(Filename As String, Key As String, Setting As String, Default)


            '###############################################
            '# Aufgabe: List Einstellungen aus einer       #
            '#          INI-Datei                          #
            '# Parameter: INI-Datei,Kategorie, Unter-      #
            '#            Kategorie, Voreinstellung        #
            '# Rckgabewerte: Wert                         #
            '###############################################

Dim Temp As String * 1000

Call GetPrivateProfileString(Key, Setting, CStr(Default), Temp, Len(Temp), Filename)
GetINISetting = DelNulls(Trim(Temp))

End Function

Private Sub SaveINISetting(Filename As String, Key As String, Setting As String, value)

            '###############################################
            '# Aufgabe: Speichert Einstellungen in einer   #
            '#          INI-Datei                          #
            '# Parameter: INI-Datei,Kategorie, Unter-      #
            '#            Kategorie, Wert der Einstellung  #
            '# Rckgabewerte: -                            #
            '###############################################

Call WritePrivateProfileString(Key, Setting, CStr(value), Filename)
   
End Sub

Private Function DelNulls(Text As String)

            '###############################################
            '# Aufgabe: Entfernt Nullen aus einem String   #
            '# Parameter: Text                             #
            '# Rckgabewerte: -                            #
            '###############################################

Dim varcounter As Long
Dim NewStr As String
            
For varcounter = 1 To Len(Text)
    If Mid$(Text, varcounter, 1) <> Chr(0) Then
        NewStr = NewStr & Mid$(Text, varcounter, 1)
    End If
Next varcounter

DelNulls = NewStr$

End Function

Public Function GetSetting(vSetting As eOtions) As Variant

If vSetting = PreviewSpeichern Then
    GetSetting = GetINISetting(mvarINIFile, "Editor", "PreviewSpeichern", False)
ElseIf vSetting = ViewGridlines Then
    GetSetting = GetINISetting(mvarINIFile, "Ansicht", "Gridlines", True)
ElseIf vSetting = ExplorerView Then
    GetSetting = GetINISetting(mvarINIFile, "Ansicht", "ExplorerView", 0)
ElseIf vSetting = Unbennantffnen Then
    GetSetting = GetINISetting(mvarINIFile, "Editor", "Unbenanntffnen", True)
ElseIf vSetting = TextMarkieren Then
    GetSetting = GetINISetting(mvarINIFile, "Editor", "TextMarkieren", False)
ElseIf vSetting = ZuletztGeffneteWiederffnen Then
    GetSetting = GetINISetting(mvarINIFile, "Editor", "Wiederffnen", False)
ElseIf vSetting = IntelliSenseAktiviert Then
    GetSetting = GetINISetting(mvarINIFile, "IntelliSense", "Aktiviert", True)
ElseIf vSetting = IntelliSenseIstGleich Then
    GetSetting = GetINISetting(mvarINIFile, "IntelliSense", "IstGleich", True)
ElseIf vSetting = StandardProject Then
    GetSetting = GetINISetting(mvarINIFile, "Projektverwaltung", "StandardProjekt", "")
ElseIf vSetting = HTML_Dokumentation Then
    GetSetting = GetINISetting(mvarINIFile, "Sonstiges", "HTML-Dokumentation", "")
ElseIf vSetting = FTPPasswort Then
    GetSetting = GetINISetting(mvarINIFile, "FTP-Client", "Passwort", "")
ElseIf vSetting = FTPServer Then
    GetSetting = GetINISetting(mvarINIFile, "FTP-Client", "Server", "")
ElseIf vSetting = FTPUserName Then
    GetSetting = GetINISetting(mvarINIFile, "FTP-Client", "Username", "")
ElseIf vSetting = ExterneAnwendung Then
    GetSetting = GetINISetting(mvarINIFile, "Sonstiges", "Externe Anwendung", "")
ElseIf vSetting = WordWrap Then
    GetSetting = GetINISetting(mvarINIFile, "Editor", "WordWrap", True)
ElseIf vSetting = ZwischenAblageRingElemente Then
    GetSetting = GetINISetting(mvarINIFile, "Sonstiges", "ZwischenAblageRingElemente", 10)
ElseIf vSetting = Schriftart Then
    GetSetting = GetINISetting(mvarINIFile, "Schrift", "Schriftart", "Courier New")
ElseIf vSetting = Schriftgre Then
    GetSetting = GetINISetting(mvarINIFile, "Schrift", "Schriftgre", 9)
ElseIf vSetting = UmlautKonvertierung Then
    GetSetting = GetINISetting(mvarINIFile, "Editor", "UmlautKonvertierung", True)
ElseIf vSetting = ProjektExplorerffnen Then
    GetSetting = GetINISetting(mvarINIFile, "Editor", "ProjektExplorerffnen", True)
End If

End Function

Public Sub SaveSetting(vSetting As eOtions, value As Variant)

If vSetting = PreviewSpeichern Then
    SaveINISetting mvarINIFile, "Editor", "PreviewSpeichern", value
ElseIf vSetting = ViewGridlines Then
    SaveINISetting mvarINIFile, "Ansicht", "Gridlines", value
ElseIf vSetting = ExplorerView Then
    SaveINISetting mvarINIFile, "Ansicht", "ExplorerView", value
ElseIf vSetting = Unbennantffnen Then
    SaveINISetting mvarINIFile, "Editor", "Unbenanntffnen", value
ElseIf vSetting = TextMarkieren Then
    SaveINISetting mvarINIFile, "Editor", "TextMarkieren", value
ElseIf vSetting = ZuletztGeffneteWiederffnen Then
    SaveINISetting mvarINIFile, "Editor", "Wiederffnen", value
ElseIf vSetting = IntelliSenseAktiviert Then
    SaveINISetting mvarINIFile, "IntelliSense", "Aktiviert", value
ElseIf vSetting = IntelliSenseIstGleich Then
    SaveINISetting mvarINIFile, "IntelliSense", "IstGleich", value
ElseIf vSetting = StandardProject Then
    SaveINISetting mvarINIFile, "Projektverwaltung", "StandardProjekt", value
ElseIf vSetting = HTML_Dokumentation Then
    SaveINISetting mvarINIFile, "Sonstiges", "HTML-Dokumentation", value
ElseIf vSetting = FTPPasswort Then
    SaveINISetting mvarINIFile, "FTP-Client", "Passwort", value
ElseIf vSetting = FTPServer Then
    SaveINISetting mvarINIFile, "FTP-Client", "Server", value
ElseIf vSetting = FTPUserName Then
    SaveINISetting mvarINIFile, "FTP-Client", "Username", value
ElseIf vSetting = ExterneAnwendung Then
    SaveINISetting mvarINIFile, "Sonstiges", "Externe Anwendung", value
ElseIf vSetting = WordWrap Then
    SaveINISetting mvarINIFile, "Editor", "WordWrap", value
ElseIf vSetting = ZwischenAblageRingElemente Then
    SaveINISetting mvarINIFile, "Sonstiges", "ZwischenAblageRingElemente", value
ElseIf vSetting = Schriftart Then
    SaveINISetting mvarINIFile, "Schrift", "Schriftart", value
ElseIf vSetting = Schriftgre Then
    SaveINISetting mvarINIFile, "Schrift", "Schriftgre", value
ElseIf vSetting = UmlautKonvertierung Then
    SaveINISetting mvarINIFile, "Editor", "UmlautKonvertierung", value
ElseIf vSetting = ProjektExplorerffnen Then
    SaveINISetting mvarINIFile, "Editor", "ProjektExplorerffnen", value
End If

End Sub

