Attribute VB_Name = "modDeklarationen"
Option Explicit

Public Type Zwischenablage
    Text1 As String
    Text2 As String
    Text3 As String
End Type

Public Const vbQuote = """"

Public cfrmChild As frmChild
Public colDokumente As Collection
Public Zwischenablage As Zwischenablage
Public colPlugIns As Collection

Function ColorToHTML(clr As Long) As String

            '#################################################
            '# Aufgabe: Konvertieren eines Long - Farbwertes #
            '#          in einen Hexadezimalwert             #
            '# Parameter: Long-Farbwert                      #
            '# Rckgabewerte: RGB-Farbwert                   #
            '#################################################

Dim R As RGBType, RL As RGBLongType
RL.clr = clr
LSet R = RL
Dim aR As String, aG As String, aB As String
With R
    aR = Trim$(Hex$(.R)): If Len(aR) = 1 Then aR = "0" & aR     'Wenn die Lnge 1 ist 0
    aG = Trim$(Hex$(.g)): If Len(aG) = 1 Then aG = "0" & aG     'anhngen (korrekter HTML-Farbecode !)
    aB = Trim$(Hex$(.b)): If Len(aB) = 1 Then aB = "0" & aB
End With
ColorToHTML = aR & aG & aB
    
End Function

Public Function FarbeUmkehren(Color)

            '##############################################
            '# Aufgabe: Umkehren der Farbe um die Be-     #
            '#          schriftung des Labels immmer le-  #
            '#          sen zu knnen                     #
            '# Parameter: Farbe                           #
            '# Rckgabewerte: -                           #
            '##############################################

Dim Rot As Integer
Dim Grn As Integer
Dim Blau As Integer

Rot = Color Mod 256         'Umkehrung der Farbe
Color = Color \ 256
Grn = Color Mod 256
Color = Color \ 256
Blau = Color Mod 256
FarbeUmkehren = RGB(255 - Rot, 255 - Grn, 255 - Blau) 'Genau umgekehrte Farbe wie Hintergrundfarbe

End Function

Function GetPath(hwnd As Long, Num As Long) As String

            '#################################################
            '# Aufgabe: Ermitteln des Pfadnamens anhand der  #
            '#          bergebenen Konstante                #
            '# Parameter: Pfad-Konstante                     #
            '# Rckgabewerte: Pfad                           #
            '#################################################

Dim result As Long, Buff As String
Dim idl As ITEMIDLIST
   
result = SHGetSpecialFolderLocation(hwnd, Num, idl)
If result = NOERROR Then
    Buff = Space$(512)
    result = SHGetPathFromIDList(ByVal idl.mkid.cb, ByVal Buff)
    If result Then GetPath = Trim$(Buff)
End If

End Function

Public Function UmlautToHTML(Umlaut) As String
            '##############################################
            '# Aufgabe: Konvertieren eines Sonderzeichens #
            '#          oder Umlautes in HTML             #
            '# Parameter: Umlaut/Sonderzeichen            #
            '# Rckgabewerte: HTML-Umlaut/Sonderzeichen   #
            '##############################################
            
Select Case Umlaut

    Case ""
    UmlautToHTML = "&auml;"
    
    Case ""
    UmlautToHTML = "&ouml;"
    
    Case ""
    UmlautToHTML = "&uuml;"
    
    Case ""
    UmlautToHTML = "&Auml;"

    Case ""
    UmlautToHTML = "&Ouml;"
    
    Case ""
    UmlautToHTML = "&Uuml;"
    
    Case ""
    UmlautToHTML = "&szlig;"
    
    Case "Leerzeichen"
    UmlautToHTML = "&nbsp;"
    
    Case "<"
    UmlautToHTML = "&lt;"
    
    Case ">"
    UmlautToHTML = "&gt;"
    
    Case "&"
    UmlautToHTML = "&amp;"

    Case """"
    UmlautToHTML = "&quot;"
    
    Case ""
    UmlautToHTML = "&sect;"

    Case "(C)"
    UmlautToHTML = "&copy;"
    
    Case "(R)"
    UmlautToHTML = "&reg;"

    Case "(TM)"
    UmlautToHTML = "&trade;"
    
    Case "<<"
    UmlautToHTML = "&laquo;"
    
    Case ">>"
    UmlautToHTML = "&raquo;"

End Select

End Function

Public Sub TemplatesLaden()

Dim File$, hFile&, FD As WIN32_FIND_DATA

hFile = FindFirstFile(App.Path & "\templates\*.*", FD)
frmMain.tolTemplates.Buttons.Clear

If hFile = 0 Then Exit Sub

Do
    File = Left$(FD.cFileName, InStr(FD.cFileName, Chr(0)) - 1)
   If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY Then
        If (File <> ".") And (File <> "..") Then
            frmMain.tolTemplates.Buttons.Add , File, File
        End If
   End If
   
Loop While FindNextFile(hFile, FD)

Call FindClose(hFile)

End Sub

Sub AusschneidenMulti(NummerDerZwischenablage)

            '#################################################
            '# Aufgabe: Ausschneiden eines Textes und        #
            '#          kopieren in die Zwischenablage       #
            '# Parameter: Nummer der Zwischenablage          #
            '# Rckgabewerte: -                              #
            '#################################################

Dim cUndo As New clsUndo

Select Case NummerDerZwischenablage
    Case 1
    Zwischenablage.Text1 = frmMain.ActiveForm.rtfText.SelText
    
    Case 2
    Zwischenablage.Text2 = frmMain.ActiveForm.rtfText.SelText
    
    Case 3
    Zwischenablage.Text3 = frmMain.ActiveForm.rtfText.SelText
End Select

frmMain.ActiveForm.rtfText.SelText = ""                 'Markierung lschen

Ende:

End Sub

Sub KopierenMulti(NummerDerZwischenablage)

            '#################################################
            '# Aufgabe: Kopieren eines Textes in die         #
            '#          Multi-Zwischenablage                 #
            '# Parameter: Nummer der Zwischenablage          #
            '# Rckgabewerte: -                              #
            '#################################################


Select Case NummerDerZwischenablage
    Case 1
    Zwischenablage.Text1 = frmMain.ActiveForm.rtfText.SelText
    
    Case 2
    Zwischenablage.Text2 = frmMain.ActiveForm.rtfText.SelText
    
    Case 3
    Zwischenablage.Text3 = frmMain.ActiveForm.rtfText.SelText
    
End Select

End Sub

Public Sub EinfgenMulti(NummerDerZwischenablage)

            '#################################################
            '# Aufgabe: Einfgen eines Textes aus de         #
            '#          Multi-Zwischenablage                 #
            '# Parameter: Nummer der Zwischenablage          #
            '# Rckgabewerte: -                              #
            '#################################################

Select Case NummerDerZwischenablage
    Case 1
    frmMain.ActiveForm.Paste Zwischenablage.Text1
      
    Case 2
    frmMain.ActiveForm.Paste Zwischenablage.Text2
    
    Case 3
    frmMain.ActiveForm.Paste Zwischenablage.Text3
    
End Select

End Sub

Public Function FileExists(ByVal sFileName$) As Boolean


            '###############################################
            '# Aufgabe: Prft, bo eine Datei existiert und #
            '#          gibt das Ergebnis zurck           #
            '# Parameter: Dateiname                        #
            '# Rckgabewerte: Dateiexistenz                #
            '###############################################

Dim hFile&, Win32FindData As WIN32_FIND_DATA
  
sFileName = Trim$(sFileName)
hFile = FindFirstFile(sFileName, Win32FindData)

If (hFile <> INVALID_HANDLE_VALUE) And (hFile <> ERROR_NO_MORE_FILES) Then
    FileExists = True
ElseIf GetFileAttributes(sFileName) <> (-1) Then
    FileExists = True
End If
  
Call FindClose(hFile)

End Function

Public Sub SaveOpenFiles()

Dim DateiNr As Long
Dim cChildForm As frmChild

DateiNr = FreeFile

Open App.Path & "\files.txt" For Output As DateiNr

    For Each cChildForm In colDokumente
        If InStr(cChildForm.caption, "(Unbenannt") = 0 Then
            Print #DateiNr, cChildForm.caption
        End If
    Next

Close DateiNr

End Sub

Public Sub OpenRecentFiles()

On Error GoTo Fehler

Dim DateiNr As Long
Dim strFile As String
DateiNr = FreeFile

Open App.Path & "\files.txt" For Input As DateiNr

    Do While Not EOF(DateiNr)
        Line Input #DateiNr, strFile
        If FileExists(strFile) Then
            frmMain.ffnen strFile
        End If
    Loop

Close DateiNr

Exit Sub
Fehler:

If Err.Number <> 53 Then
    MsgBox Err.Description
End If
End Sub

Public Function ListFindText(lstListBox As ListBox, strFindText As String, Optional ByVal intFromIndex As Long = -1, Optional ByVal blnSelect As Boolean = True) As Long

Dim lngMsg As Long
Dim lngIndex As Long
Dim blnExact As Boolean
    
Const LB_ERR = (-1)
Const LB_FINDSTRING = &H18F
Const LB_SELECTSTRING = &H18C
Const LB_FINDSTRINGEXACT = &H1A2
    
Select Case blnExact
    Case False
        Select Case blnSelect
            Case True
                lngMsg = LB_SELECTSTRING
            Case False
                lngMsg = LB_FINDSTRING
        End Select
        
        SendMessage lstListBox.hwnd, WM_SETREDRAW, 0, 0
        ListFindText = SendMessageStr(lstListBox.hwnd, lngMsg, intFromIndex, strFindText)
        SendMessage lstListBox.hwnd, WM_SETREDRAW, 1, 0
        lstListBox.Refresh
    Case True
        With lstListBox
           lngIndex = SendMessageStr(.hwnd, LB_FINDSTRINGEXACT, intFromIndex, strFindText)
            If blnSelect Then
                .ListIndex = lngIndex
            End If
        End With
        ListFindText = lngIndex
    End Select
    
End Function

Public Function GetGIFSize(strGIFFile As String) As POINTAPI

Dim FF As Integer
Dim strData As String

FF = FreeFile
Open strGIFFile For Binary As #FF
    strData = Input(10, #FF)
Close #1

GetGIFSize.x = Asc(Mid$(strData, 8, 1)) * 256 + Asc(Mid$(strData, 7, 1))
GetGIFSize.y = Asc(Mid$(strData, 10, 1)) * 256 + Asc(Mid$(strData, 9, 1))

End Function

Public Sub HTMLDokumentation()

Dim result As Long
Dim strDateiName As String
strDateiName = frmMain.clsOptions.GetSetting(HTML_Dokumentation)
If FileExists(strDateiName) = False Then
    MsgBox "Es wurde keine HTML-Dokumentation angeben oder der Dateiname ist ungltig," & vbCrLf & "Bitte whlen Sie in den Optionen unter 'Verschiedenes' eine HTML-Dokumentation aus !", vbInformation, "HTML-Dokumentation"
Else: result = ShellExecute(0&, "Open", strDateiName, "", "", 1)
End If

End Sub

Public Sub EinzugVerkleinern()

Dim lngSelalt As Long
Dim strNeu As String

lngSelalt = frmMain.ActiveForm.rtfText.SelStart

If InStr(frmMain.ActiveForm.rtfText.Text, vbCrLf) > InStr(frmMain.ActiveForm.rtfText.Text, vbTab) Then
    strNeu = Replace(frmMain.ActiveForm.rtfText.SelText, vbCrLf & vbTab, vbCrLf)
Else
    strNeu = Replace(frmMain.ActiveForm.rtfText.SelText, vbTab, "", , 1)
    strNeu = Replace(strNeu, vbCrLf & vbTab, vbCrLf)
End If

frmMain.ActiveForm.bolLocked = True
frmMain.ActiveForm.GetActualState
frmMain.ActiveForm.cUndo.mvarcolUndo.Add frmMain.ActiveForm.cActualState
frmMain.ActiveForm.rtfText.SelText = strNeu
frmMain.ActiveForm.bolLocked = False

frmMain.ActiveForm.rtfText.SelStart = lngSelalt
frmMain.ActiveForm.rtfText.SelLength = Len(strNeu)

End Sub

Public Sub EinzugVergrern()

Dim lngSelalt As Long
Dim strNeu As String

lngSelalt = frmMain.ActiveForm.rtfText.SelStart

strNeu = vbTab & Replace(frmMain.ActiveForm.rtfText.SelText, vbCrLf, vbCrLf & vbTab)

frmMain.ActiveForm.bolLocked = True
frmMain.ActiveForm.GetActualState
frmMain.ActiveForm.cUndo.mvarcolUndo.Add frmMain.ActiveForm.cActualState
frmMain.ActiveForm.rtfText.SelText = strNeu
frmMain.ActiveForm.bolLocked = False

frmMain.ActiveForm.rtfText.SelStart = lngSelalt
frmMain.ActiveForm.rtfText.SelLength = Len(strNeu)

End Sub

Public Function GetExtension(strDateiName) As String

GetExtension = Right$(strDateiName, Len(strDateiName) - InStrRev(strDateiName, "."))

End Function

Public Function ContainsText(strDateiName As String, strStringCheck As String, Optional bolCaseSensitive As Boolean = False) As Boolean

On Error GoTo Fehlerbehandlung

Dim lngDateiNr As Long
Dim strText As String
lngDateiNr = FreeFile

Open strDateiName For Input As lngDateiNr
    strText = Input(LOF(lngDateiNr), lngDateiNr)
Close lngDateiNr

If Not bolCaseSensitive Then
    strText = UCase(strText)
    strStringCheck = UCase(strStringCheck)
End If

If InStr(strText, strStringCheck) > 0 Then
    ContainsText = True
Else: ContainsText = False

End If

Exit Function
Fehlerbehandlung:

If Err.Number = 62 Then
    ContainsText = False
End If

End Function

Public Function ReplaceTextInFile(strDateiName As String, strFind As String, strReplace As String) As Boolean

Dim lngDateiNr As Long
Dim strText As String
Dim strTextNew As String
lngDateiNr = FreeFile

On Error GoTo Fehlerbehandlung

Open strDateiName For Input As lngDateiNr
    strText = Input(LOF(lngDateiNr), lngDateiNr)
Close lngDateiNr

strTextNew = Replace(strText, strFind, strReplace)

lngDateiNr = FreeFile

Open strDateiName For Output As lngDateiNr
    Print #lngDateiNr, strTextNew
Close lngDateiNr

If strTextNew <> strText Then ReplaceTextInFile = True

Exit Function
Fehlerbehandlung:

If Err.Number = 62 Then
    ReplaceTextInFile = False
ElseIf Err.Number = 75 Then
    ReplaceTextInFile = False
Else
    MsgBox Err.Description, vbExclamation
    ReplaceTextInFile = False
End If

End Function

Public Function LoadIcon(Size&, File$) As IPictureDisp

Dim result As Long
Dim Unkown As IUnknown
Dim Icon As IconType
Dim CLSID As CLSIdType
Dim ShellInfo As ShellFileInfoType

Call SHGetFileInfo(File, 0, ShellInfo, Len(ShellInfo), Size)

Icon.cbSize = Len(Icon)
Icon.picType = vbPicTypeIcon
Icon.hIcon = ShellInfo.hIcon
CLSID.id(8) = &HC0
CLSID.id(15) = &H46
result = OleCreatePictureIndirect(Icon, CLSID, 1, Unkown)
Set LoadIcon = Unkown
  
End Function

Public Function GetFileVersion(ByVal FilePath As String) As String

Dim SVer As String, strFVer, Buff() As Byte
Dim l As Long, BuffL As Long, Pointer As Long, VERSION As VS_FIXEDFILEINFO
 
l = GetFileVersionInfoSize(FilePath, 0&)

If l < 1 Then
    GetFileVersion = -1
    Exit Function
Else
    ReDim Buff(l)
    Call GetFileVersionInfo(FilePath, 0&, l, Buff(0))
    Call VerQueryValue(Buff(0), "\", Pointer, BuffL)
    Call MoveMemory(VERSION, Pointer, Len(VERSION))
      
    With VERSION
        strFVer = Format$(.dwFileVersionMSh) & "." & Format$(.dwFileVersionMSl) & "." & Format$(.dwFileVersionLSh) & "." & Format$(.dwFileVersionLSl)
    End With
       
End If

GetFileVersion = strFVer

End Function

Public Sub Main()

frmMain.Show

End Sub

Public Sub LoadPlugIns()

On Error GoTo Err

Dim strFileName As String
Dim strBasename As String
Dim cPlugIn As Object
Dim cInterFace As clsPlugInInterface
Set cInterFace = New clsPlugInInterface
Set colPlugIns = New Collection

strFileName = Dir(App.Path & "\PlugIns\*.dll")

Do While strFileName <> ""
    strBasename = Left(strFileName, Len(strFileName) - 4)
    Set cPlugIn = CreateObject(strBasename & ".clsPlugIt")
    Set cPlugIn.mvarXPadApp = cInterFace
    colPlugIns.Add cPlugIn
    Load frmMain.mnuToolsPluginsPlugins(frmMain.mnuToolsPluginsPlugins.UBound + 1)
    frmMain.mnuToolsPluginsPlugins(frmMain.mnuToolsPluginsPlugins.Count - 1).caption = Left$(strFileName, Len(strFileName) - 4)
    strFileName = Dir()
Loop

If frmMain.mnuToolsPluginsPlugins.Count > 1 Then
    frmMain.mnuToolsPluginsPlugins(0).Visible = False
End If

Exit Sub
Err:

MsgBox Err.Description & vbCrLf & vbCrLf & "Evtl.  wurde ein PlugIn gefunden das in der Systemregistrierung aber nicht" & vbCrLf & "eingetragen ist. Bitte registrieren sie das PlugIn mittels: " & vbCrLf & "regsvr32 Plugin.dll" & vbCrLf & vbCrLf & "Wenn diese Meldung danach immer noch erscheint, kontaktieren sie bitte support@palmbytes.de", vbInformation, "PlugIn"

End Sub

Public Sub FlatListBox(lngListBoxhWnd As Long)

Dim nStyle As Long
    
nStyle = GetWindowLong(lngListBoxhWnd, GWL_STYLE)
nStyle = nStyle And Not WS_BORDER

SetWindowLong lngListBoxhWnd, GWL_STYLE, nStyle
SetWindowPos lngListBoxhWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_NOZORDER

End Sub

Public Sub ClipBoardChanged()

Dim strClipboardText As String
Dim n As Integer

strClipboardText = Clipboard.GetText

For n = 0 To frmMain.lstZwischenablageRing.ListCount
    If frmMain.lstZwischenablageRing.List(n) = strClipboardText Then
        If strClipboardText <> "" Then
            frmMain.lstZwischenablageRing.RemoveItem n
        End If
    End If
Next
If strClipboardText <> "" Then
    For n = frmMain.clsOptions.GetSetting(ZwischenAblageRingElemente) To frmMain.lstZwischenablageRing.ListCount
        frmMain.lstZwischenablageRing.RemoveItem 0
    Next
    frmMain.lstZwischenablageRing.AddItem strClipboardText
End If

End Sub

Public Function GetSystemDirectory() As String

Dim sSave As String, Ret As Long
sSave = Space(255)
Ret = GetSystemDirectoryII(sSave, 255)
sSave = Left$(sSave, Ret)

GetSystemDirectory = sSave

End Function

Public Sub UpdateProjectMenu()

Dim File As String, hFile As Long, FD As WIN32_FIND_DATA
Dim n As Integer

If frmMain.tolExplorer.Buttons("Projekt").ButtonMenus.Count > 5 Then
    For n = 5 To frmMain.tolExplorer.Buttons("Projekt").ButtonMenus.Count
        frmMain.tolExplorer.Buttons("Projekt").ButtonMenus.Remove frmMain.tolExplorer.Buttons("Projekt").ButtonMenus.Count
    Next
End If

hFile = FindFirstFile(App.Path & "\projects\*.*", FD)
        
If hFile = 0 Then Exit Sub
    
Do
    File = Left$(FD.cFileName, InStr(FD.cFileName, Chr(0)) - 1)
    If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY Then
        If (File <> ".") And (File <> "..") And File <> "" And File <> " " Then
            frmMain.tolExplorer.Buttons("Projekt").ButtonMenus.Add , File, File
        End If
    End If
       
Loop While FindNextFile(hFile, FD)

FindClose hFile

End Sub

Public Sub UpdateProject()

Dim cProject As clsProject
Set cProject = New clsProject
Dim strDefaultDir As String

frmMain.staStatus.Panels("Projekt").Text = Right$(frmMain.strProject, Len(frmMain.strProject) - InStrRev(frmMain.strProject, "\"))

If frmMain.strProject = "" Then
    cProject.ProjectFile = frmSelectProject.GetProjectName
    Unload frmSelectProject
    strDefaultDir = cProject.GetSetting(Default_Directory)
Else
    cProject.ProjectFile = frmMain.strProject
    strDefaultDir = cProject.GetSetting(Default_Directory)
End If

frmMain.clsOptions.SaveSetting StandardProject, frmMain.strProject
If frmMain.strProject = "" Then Exit Sub

If Right(strDefaultDir, 1) = "\" Then
    strDefaultDir = Left(strDefaultDir, Len(strDefaultDir) - 1)
End If
 
If FileExists(strDefaultDir) = False Or strDefaultDir = "\" Then
    MsgBox "Ungltiges Verzeichnis in Projekt !" & vbCrLf & "Bitte ndern Sie in der Projektverwaltung das " & vbCrLf _
     & "Standardverzeichnis dieses Projektes !"
     Exit Sub
Else:
    frmMain.Explorer.Root = ""
    frmMain.Explorer.Root = strDefaultDir
    frmMain.Explorer.Visible = True
    frmMain.Explorer.Pfad = strDefaultDir
    frmMain.lstZwischenablageRing.Visible = False
    frmMain.tolExplorer.Visible = True
    frmMain.lblFileExplorer.caption = "Projekt-Explorer"
End If

End Sub

Public Function ReplaceInBorders(Str As String, StartStr As String, EndStr As String, ReplaceBy As String, Optional ByVal Start As Long = 1, Optional ByVal Count As Long) As String

Dim nStartPos As Long
Dim nEndPos As Long
Dim nResult As String
Dim nStart As Long
Dim nFound As Boolean
Dim nReplaceLen As Long
Dim nLenStartStr As Long
Dim nLenEndStr As Long
    
ReplaceInBorders = Str

nStart = Start
     
nLenStartStr = Len(StartStr)
nLenEndStr = Len(EndStr)
nReplaceLen = Len(ReplaceBy) + nLenStartStr + nLenEndStr

If Count > 0 Then
    Do
        nFound = InStrBorders(ReplaceInBorders, StartStr, EndStr, nStartPos, nEndPos, nStart)
        If nFound Then
            ReplaceInBorders = Left$(ReplaceInBorders, nStartPos + nLenStartStr - 1) & ReplaceBy & Mid$(ReplaceInBorders, nEndPos - nLenEndStr + 1)
            nStart = nStartPos + nReplaceLen
            Count = Count - 1
            If Count = 0 Then
                Exit Do
            End If
        Else
            Exit Do
        End If
    Loop
Else
    Do
        nFound = InStrBorders(ReplaceInBorders, StartStr, EndStr, nStartPos, nEndPos, nStart)
        If nFound Then
            ReplaceInBorders = Left$(ReplaceInBorders, nStartPos + nLenStartStr - 1) & ReplaceBy & Mid$(ReplaceInBorders, nEndPos - nLenEndStr + 1)
            nStart = nStartPos + nReplaceLen
        Else
            Exit Do
        End If
    Loop
End If

End Function

Public Function InStrBorders(Str As String, StartStr As String, EndStr As String, Optional StartPos As Long, Optional EndPos As Long, Optional ByVal Start As Long = 1, Optional ByVal CompareMethod As VbCompareMethod = vbBinaryCompare) As Boolean

Dim nEndPos As Long
    
StartPos = InStr(Start, Str, StartStr, CompareMethod)
If StartPos Then
    nEndPos = InStr(StartPos + Len(StartStr), Str, EndStr, CompareMethod)
    If nEndPos Then
        EndPos = nEndPos + Len(EndStr) - 1
        InStrBorders = True
    End If
End If

End Function

Public Sub UpdateDates()

frmMain.ActiveForm.rtfText.Text = ReplaceInBorders(frmMain.ActiveForm.rtfText.Text, "<!--DATE-->", "<!--/DATE-->", Date)

End Sub
